package org.nl.acs.task.service;

import org.nl.acs.task.domain.TaskFeedback;
import org.nl.acs.task.service.dto.TaskFeedbackDto;
import org.nl.acs.task.service.dto.TaskFeedbackQueryParam;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.common.base.PageInfo;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface TaskFeedbackService extends CommonService<TaskFeedback>  {

    static final String CACHE_KEY = "taskFeedback";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<TaskFeedbackDto>
    */
    PageInfo<TaskFeedbackDto> queryAll(TaskFeedbackQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<TaskFeedbackDto>
    */
    List<TaskFeedbackDto> queryAll(TaskFeedbackQueryParam query);

    TaskFeedback getById(String id);
    TaskFeedbackDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(TaskFeedbackDto resources);
    int updateById(TaskFeedbackDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<TaskFeedbackDto> all, HttpServletResponse response) throws IOException;

    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<TaskFeedbackDto>
     */
    List<TaskFeedbackDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param taskback_id ID
     * @return TaskFeedback
     */
//    TaskFeedbackDto findById(String taskback_id);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return TaskFeedback
     */
    TaskFeedbackDto findByCode(String code);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(TaskFeedbackDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(TaskFeedbackDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<TaskFeedbackDto> dtos, HttpServletResponse response) throws IOException;

    /**
     * 重置
     *
     * @param ids
     */
    void retry(String ids);

    /**
     * 作废
     *
     * @param ids
     */
    void invalid(String ids);
}
